program cw4_59d;
{ Program testujacy dzialanie funkcji, okreslajacej  }
{ dzien tygodnia zadanego dnia. Wykorzystamy funkcje }
{ z cwiczenia 4_53d.                                 }
{ Katalog r4_11 : 4_59d.pas                          }

uses
  Crt;

type
  { Typ rekordowy, w ktorym bedzie pamietana data }
  TData = record
            Dzien, Miesiac : Byte;
            Rok : Integer;
          end;

  TDniTygodnia = (niedziela, poniedzialek, wtorek, sroda,
                  czwartek, piatek, sobota);

const
  NazwyDniTygodnia : array [TDniTygodnia] of String =
                 ('niedziela', 'poniedzialek', 'wtorek', 'sroda',
                  'czwartek', 'piatek', 'sobota');

function LiczbaDniWRoku (Rok : Integer) : Integer;
{ Funkcja podaje liczbe dni w roku Rok. }
begin
  if (Rok mod 4 = 0) and 
     ((Rok mod 100 <> 0) or (Rok mod 400 = 0)) then
    LiczbaDniWRoku := 366 { rok przestepny }
  else
    LiczbaDniWRoku := 365 { rok nie jest przestepny }
end; {----------------------------- LiczbaDniWRoku -}

function LiczbaDniWMiesiacu (Miesiac : Byte; Rok : Integer) : Byte;
{ Funkcja podaje liczbe dni w miesiacu Miesiac roku Rok. }
begin
  case Miesiac of
    1, 3, 5, 7, 8, 10, 12: LiczbaDniWMiesiacu := 31;
    2: if LiczbaDniWRoku (Rok) = 366 then
         LiczbaDniWMiesiacu := 29
       else
         LiczbaDniWMiesiacu := 28
    else
      LiczbaDniWMiesiacu := 30
  end;
end; {---------------------------------------- LiczbaDniWMiesiacu -}

function LiczbaDniDoKoncaMiesiaca (Data : TData) : Byte;
{ Funkcja podaje liczbe dni od podanej daty do konca biezacego }
{ miesiaca.                                                    }
begin
  LiczbaDniDoKoncaMiesiaca := LiczbaDniWMiesiacu (Data.Miesiac, Data.Rok)-Data.Dzien;
end; {------------------------------ LiczbaDniDoKoncaMiesiaca -}

function LiczbaDniDoKoncaRoku (Data : TData) : Integer;
{ Funkcja podaje liczbe dni od podanej daty do konca biezacego }
{ roku.                                                        }

var
  Liczba : Integer;
  I : Byte;
begin
  Liczba := LiczbaDniDoKoncaMiesiaca (Data);
  for I := Data.Miesiac+1 to 12 do
    Liczba := Liczba + LiczbaDniWMiesiacu (I, Data.Rok);
  LiczbaDniDoKoncaRoku := Liczba
end; {---------------------------------- LiczbaDniDoKoncaRoku -}

function DataWieksza (D1, D2 : TData) : Boolean;
{ Funkcja sprawdza, czy data D1 jest wieksza od daty D2. }
var
  D : Boolean;
begin
  D := False;
  if D1.Rok > D2.Rok then
    D := True
  else
    if D1.Rok = D2.Rok then
      if D1.Miesiac > D2.Miesiac then
        D := True
      else
        if D1.Miesiac = D2.Miesiac then
          if D1.Dzien > D2.Dzien then
            D := True;
  DataWieksza := D;
end; {------------------------------------- DataWieksza -}

function LiczbaDniPomiedzyDatami (D1, D2 : TData) : LongInt;
{ Funkcja podaje liczbe dni od dnia D1 do D2. }
var
  Liczba : LongInt;
  I, Mnoznik : Integer;
  Pom : TData;
begin
  if DataWieksza (D1, D2) then
  begin
    Mnoznik := -1;
    Pom := D1; D1 := D2; D2 := Pom;
  end
  else
    Mnoznik := 1;
  Liczba := LiczbaDniDoKoncaRoku (D1);
  for I := D1.Rok+1 to D2.Rok do
    Liczba := Liczba + LiczbaDniWRoku (I);
  Liczba := Liczba - LiczbaDniDoKoncaRoku (D2);
  LiczbaDniPomiedzyDatami := Mnoznik * Liczba;
end; {-------------------------- LiczbaDniPomiedzyDatami -}

function DzienTygodnia (D : TData) : TDniTygodnia;
{ Funkcja oblicza, jakim dniem tygodnia jest wskazany dnien }
{ opierajac sie na informacji, ze 1.1.1800 byl sroda.       }
var
  DStart : TData;
  Liczba : LongInt;
begin
  DStart.Dzien := 1; DStart.Miesiac := 1; DStart.Rok := 1800;
  Liczba := (LiczbaDniPomiedzyDatami (DStart, D) + 3) mod 7;
  DzienTygodnia := TDniTygodnia (Liczba);
end; {-------------------------------------- DzienTygodnia -}

var
  D : TData;
  Dzien : TDniTygodnia;

begin
  ClrScr;

  { Tutaj mozesz testowac wlasne daty, lub zaprogramowac }
  { wprowadzanie danych przez uzytkownika.               }

  D.Dzien := 1; D.Miesiac := 1; D.Rok := 2000;

  Dzien := DzienTygodnia (D);
  Writeln ('Ten dzien to ', NazwyDniTygodnia[Dzien]);
  Readln;
end.
